#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GiantSharkIntegral.h"
std::auto_ptr<Fish_GiantSharkIntegral> Fish_GiantSharkIntegral::msSingleton(nullptr);

int Fish_GiantSharkIntegral::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkIntegralData* Fish_GiantSharkIntegral::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GiantSharkIntegralData>& Fish_GiantSharkIntegral::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkIntegral::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GiantSharkIntegral.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkIntegralData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mMinimumIntegral = element->IntAttribute("MinimumIntegral");
		data.mMaximumIntegral = element->IntAttribute("MaximumIntegral");
		data.mGold = element->IntAttribute("Gold");
		data.mAdditionalRewards = element->IntAttribute("AdditionalRewards");
		data.mRewardCard = element->IntAttribute("RewardCard");
		data.mDisplaySort = element->IntAttribute("DisplaySort");
		data.mDisplayCardType = element->Attribute("DisplayCardType");
		data.mNewGiftWeight = element->IntAttribute("NewGiftWeight");
		data.mNewWeight = element->IntAttribute("NewWeight");
		data.mGiftWeight = element->IntAttribute("GiftWeight");
		data.mComWeight = element->IntAttribute("ComWeight");
		data.mNorWeight = element->IntAttribute("NorWeight");
		data.mOnListWeight = element->IntAttribute("OnListWeight");
		data.mNewGiftWeight1 = element->IntAttribute("NewGiftWeight1");
		data.mNewWeight1 = element->IntAttribute("NewWeight1");
		data.mGiftWeight1 = element->IntAttribute("GiftWeight1");
		data.mComWeight1 = element->IntAttribute("ComWeight1");
		data.mNorWeight1 = element->IntAttribute("NorWeight1");
		data.mOnListWeight1 = element->IntAttribute("OnListWeight1");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GiantSharkIntegral Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkIntegral::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GiantSharkIntegral");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GiantSharkIntegral");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GiantSharkIntegralData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "MinimumIntegral", data.mMinimumIntegral);
		LuaCfgHelper::readInt(L, "MaximumIntegral", data.mMaximumIntegral);
		LuaCfgHelper::readInt(L, "Gold", data.mGold);
		LuaCfgHelper::readInt(L, "AdditionalRewards", data.mAdditionalRewards);
		LuaCfgHelper::readInt(L, "RewardCard", data.mRewardCard);
		LuaCfgHelper::readInt(L, "DisplaySort", data.mDisplaySort);
		LuaCfgHelper::readString(L, "DisplayCardType", data.mDisplayCardType);
		LuaCfgHelper::readInt(L, "NewGiftWeight", data.mNewGiftWeight);
		LuaCfgHelper::readInt(L, "NewWeight", data.mNewWeight);
		LuaCfgHelper::readInt(L, "GiftWeight", data.mGiftWeight);
		LuaCfgHelper::readInt(L, "ComWeight", data.mComWeight);
		LuaCfgHelper::readInt(L, "NorWeight", data.mNorWeight);
		LuaCfgHelper::readInt(L, "OnListWeight", data.mOnListWeight);
		LuaCfgHelper::readInt(L, "NewGiftWeight1", data.mNewGiftWeight1);
		LuaCfgHelper::readInt(L, "NewWeight1", data.mNewWeight1);
		LuaCfgHelper::readInt(L, "GiftWeight1", data.mGiftWeight1);
		LuaCfgHelper::readInt(L, "ComWeight1", data.mComWeight1);
		LuaCfgHelper::readInt(L, "NorWeight1", data.mNorWeight1);
		LuaCfgHelper::readInt(L, "OnListWeight1", data.mOnListWeight1);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GiantSharkIntegral Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkIntegral::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GiantSharkIntegral* Fish_GiantSharkIntegral::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkIntegral());
	}
	return msSingleton.get();
}

void Fish_GiantSharkIntegral::Release()
{
	msSingleton.reset(nullptr);
}
